// NGCommStatGraph.js 100926
(function() {
if(document.location.pathname.indexOf("/watch/") != 0) return;
if(!window.NGCommStatGraph) NGCommStatGraph = {};

// See http://www.amcharts.com/docs/v.1/bundle/settings/line_area
NGCommStatGraph.SETTINGS = '<settings>' +
	'<redraw>true</redraw>' +
	'<plot_area>' +
	  '<margins>' +
	    '<left>30</left><top>6</top><right>10</right><bottom>19</bottom>' +
	  '</margins>' +
	'</plot_area>' +
	'<grid>' +
	  '<y_left><approx_count>5</approx_count></y_left>' +
	'</grid>' +
	'<values>' +
	  '<x><skip_first>false</skip_first></x>' +
	  '<y_left><min>0</min><skip_first>false</skip_first></y_left>' +
	'</values>' +
	'<axes>' +
	  '<x><width>0</width><tick_length>0</tick_length></x>' +
	  '<y_left><tick_length>4</tick_length></y_left>' +
	'</axes>' +
	'<graphs>' +
	  '<graph>' +
	    '<color>#FF0000</color><fill_alpha>30</fill_alpha><balloon_alpha>75</balloon_alpha>' +
	  '</graph>' +
	  '<graph>' +
	    '<color>#0000FF</color><fill_alpha>50</fill_alpha><balloon_alpha>60</balloon_alpha>' +
	    '<hidden>false</hidden><line_alpha>0</line_alpha>' +
	  '</graph>' +
	  '<graph>' +
	    '<color>#000000</color><fill_alpha>50</fill_alpha><balloon_alpha>60</balloon_alpha>' +
	    '<hidden>false</hidden><line_alpha>0</line_alpha>' +
	  '</graph>' +
	'</graphs>' +
	'<legend><enabled>false</enabled></legend>' +
	'<help>' +
	  '<button><text_color>#000000</text_color><alpha>0</alpha></button>' +
	  '<balloon>' +
	    '<alpha>80</alpha><width>350</width><text_size>11</text_size><text></text>' +
	  '</balloon>' +
	'</help>' +
	'<context_menu>' +
	  (NGCommStatGraph.NoUpdatePosition ? '' :
	    '<menu function_name="NGCommStatGraph.start(1)" title="現在位置の更新(1秒毎)"></menu>' +
	    '<menu function_name="NGCommStatGraph.start(3)" title="現在位置の更新(5秒毎)"></menu>' +
	    '<menu function_name="NGCommStatGraph.start" title="現在位置の更新(自動)"></menu>' +
	    '<menu function_name="NGCommStatGraph.stop" title="現在位置の更新を停止"></menu>') +
	  '<menu function_name="NGCommStatGraph.reload" title="最新の統計情報に更新"></menu>' +
	  '<default_items><zoom>false</zoom><print>false</print></default_items>' +
	'</context_menu>' +
  '</settings>';

NGCommStatGraph.LABEL_SETTINGS_TMPL = new Template(
	'<settings><labels><label>' +
	  '<x>#{x}</x><y>#{y}</y><rotate>true</rotate>' +
	  '<text_color>#555555</text_color><text>#{text}</text>' +
	'</label></labels></settings>');

Object.extend(NGCommStatGraph, {
	chart_id: "NGCommStatGraph",
	container: $("NGCommStatGraph_container"),
	setup: function() {
		if(this.chart) return;
		
		if(!this.path  ) this.path   = "/local/amline/";
		if(!this.width ) this.width  = 976;
		if(!this.height) this.height = 100;
		var so = new SWFObject(this.path+"amline.swf",
				this.chart_id, this.width, this.height, 9, "#FFFFFF");
		so.addVariable("path", this.path);
		so.addVariable("chart_id", this.chart_id);
		so.addVariable("chart_settings", this.quote(this.SETTINGS));
		if (!this.NoUpdatePosition) {
			so.addVariable("additional_chart_settings", this.quote(
				this.LABEL_SETTINGS_TMPL.evaluate({
					x: 21, y: this.height - 15,
					text: "========================================"
				})));
		}
		var self = this;
		var chart_data = this.getData();
		if (chart_data != null) {
			start_chart();
		} else {
			var timer = setInterval(function() {
				chart_data = self.getData();
				if (chart_data != null) {
					clearInterval(timer);
					start_chart();
				}
			}, 3000);
		}
		function start_chart() {
			so.addVariable("chart_data", chart_data);
			so.write(self.container.id);
			self.chart = $(self.chart_id);
			if (isNaN(self.reloadEvery) || self.reloadEvery < 0)
				self.reloadEvery = 60;
			if (self.reloadEvery > 0) {
				self.reloadTimer = setInterval(function() {
					self.reloadData();
				}, self.reloadEvery * 1000);
			}
			self.start();
		}
	},
	start: function(every) {
		this.setup();
		this.stop();
		if (!this.NoUpdatePosition) {
			if(!every) every = isNaN(this.updateEvery) ?
					this.getEvery() : this.updateEvery;
			if (every > 0) {
				var self = this;
				this.updateTimer = setInterval(function() {
					self.update();
				}, every * 1000);
			}
		}
	},
	stop: function() {
		if (this.updateTimer) {
			clearInterval(this.updateTimer);
			this.updateTimer = null;
		}
	},
	update: function() {
		if(this.NoUpdatePosition) return;
		try {
			var current = $("flvplayer").ext_getPlayheadTime();
			if (this.length > 0 && current >= 0) {
				var last = Math.floor(this.length / this.dataEvery) * this.dataEvery;
				if(current > last) current = last;
				var x = Math.floor(current * (this.width - 40) / last) + 21;
//console.log("length="+this.length+", current="+current+", last="+last+", x="+x);
				this.chart.setParam("labels.label[0].x", x);
			}
		} catch (e) {}
	},
	reload: function() {
		this.reloadData();
		this.update();
	},
	quote: function(str) {
		return str != null ? str.replace(/"/g, "%22") : null;
	},
	series: function(time) {
		var mm = ("00"+Math.floor(time / 60)).slice(-3);
		var ss = ( "0"+Math.floor(time % 60)).slice(-2);
		return mm+":"+ss;
	},
	toggle: function(elem) {
		if (this.container.visible()) {
			$(elem).update(elem.innerHTML.replace("隠す", "表示"));
			this.stop();
			this.container.hide();
		} else {
			this.container.show();
			this.start();
			$(elem).update(elem.innerHTML.replace("表示", "隠す"));
		}
	},
	getParams: function() {
		this.length = this.getTotalTime();
		if(isNaN(this.dataEvery)) this.dataEvery = this.getEvery();
		return window.Video.id +
				(this.dataEvery > 0 ? "&every=" + this.dataEvery : "") +
				(this.length    > 0 ? "&last="  + this.length    : "");
	},
	getEvery: function() {
		if(this.length <  150) return 1;
		if(this.length <  600) return 3;
		if(this.length < 1800) return 5;
		return 10;
	},
	getTotalTime: function() {
		try {
			var total = $("flvplayer").ext_getTotalTime();
			return Math.floor(total);
		} catch (e) {
			return window.Video.length;
		}
	},
	getData: function() {
		var data = null;
		new Ajax.Request("/cache/ngstatxml", {
			method: "GET",
			parameters: this.getParams() +"&"+ (new Date()).getTime(),
			asynchronous: false,
			onSuccess: function(r){ data = r.responseText }
		});
		return this.quote(data);
	},
	reloadData: function() {
		try {
			this.chart.reloadData(escape("/cache/ngstatxml?" + this.getParams()));
		} catch (e) {}
	},
	waitPlayer: function(status, callback) {
		var not = false;
		if (status.indexOf("!") == 0) {
			not = true;
			status = status.substring(1);
		}
		var timer = setInterval(function() {
			var player = $("flvplayer");
			if(!player) return;
			try {
				var result = player.ext_getStatus() == status;
				if (result || not) {
					clearInterval(timer);
					callback();
				}
			} catch (e) {}
		}, 500);
	},
	__empty: function() {}
});

if (NGCommStatGraph.container) {
	NGCommStatGraph.waitPlayer("playing", function() {
		NGCommStatGraph.setup();
	});
}

})();

function NGCommStatGraphToggle(elem) {
	NGCommStatGraph.toggle(elem);
}

function amClickedOnSeries(chart_id, series) {
	try {
		var tm = series.split(":");
		var sec = (tm[0] - 0) * 60 + (tm[1] - 0);
		$("flvplayer").ext_setPlayheadTime(sec);
		NGCommStatGraph.waitPlayer("!seeking", function() {
			NGCommStatGraph.update();
		});
	} catch (e) {}
}

function amError(chart_id, message) {
	if(window.console) console.log("amError: chart_id="+chart_id+", message="+message);
}
